unit Conf;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, iCoolKey;

type
  TConfForm = class(TForm)
    GroupBox1: TGroupBox;
    hkRecord: THotKey;
    chkRecord: TCheckBox;
    GroupBox2: TGroupBox;
    hkPlay: THotKey;
    chkPlay: TCheckBox;
    GroupBox3: TGroupBox;
    hkStop: THotKey;
    chkStop: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    CoolKeys    : TCoolKeys;

    BkChkRec    : Boolean;
    BkChkPly    : Boolean;
    BkChkStp    : Boolean;

    BkShortRec  : TShortCut;
    BkShortPly  : TShortCut;
    BkShortStp  : TShortCut;

    procedure   Backup();
    procedure   Restore();
    procedure   Apply();
  public

  end;

var
  ConfForm: TConfForm;

implementation

uses
    iForm, Menus, Main;

{$R *.dfm}

procedure   TConfForm.Backup();
begin
    BkChkRec := chkRecord.Checked;
    BkChkPly := chkPlay.Checked;
    BkChkStp := chkStop.Checked;

    BkShortRec := hkRecord.HotKey;
    BkShortPly := hkPlay.HotKey;
    BkShortStp := hkStop.HotKey;
end;

procedure   TConfForm.Restore();
begin
    chkRecord.Checked := BkChkRec;
    chkPlay.Checked   := BkChkPly;
    chkStop.Checked   := BkChkStp;

    hkRecord.HotKey := BkShortRec;
    hkPlay.HotKey   := BkShortPly;
    hkStop.HotKey   := BkShortStp;
end;

procedure   TConfForm.Apply();
var
    Modifiers: TShiftState;
    Virtkey: Word;
begin

    CoolKeys.Clear;

    if chkRecord.Checked then
    begin
        ShortCutToKey(hkRecord.HotKey, VirtKey, Modifiers);
        if CoolKeys.Add(MainForm.InitRecording, Modifiers, Virtkey) = -1 then
        begin
            chkRecord.Checked := False;
        end;
    end;

    if chkPlay.Checked then
    begin
        ShortCutToKey(hkPlay.HotKey, VirtKey, Modifiers);
        if CoolKeys.Add(MainForm.InitPlaying, Modifiers, Virtkey) = -1 then
        begin
            chkRecord.Checked := False;
        end;
    end;

    if chkStop.Checked then
    begin
        ShortCutToKey(hkStop.HotKey, VirtKey, Modifiers);
        if CoolKeys.Add(MainForm.InitStopping, Modifiers, Virtkey) = -1 then
        begin
            chkRecord.Checked := False;
        end;
    end;

end;

procedure TConfForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title;

    LoadForm(Self);
    CoolKeys := TCoolKeys.Create;
    Apply();
end;

procedure TConfForm.FormDestroy(Sender: TObject);
begin
    CoolKeys.Free;
    SaveForm(Self);
end;

procedure TConfForm.FormShow(Sender: TObject);
begin
    Backup();
    CoolKeys.Clear;
end;

procedure TConfForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if ModalResult = mrOK then
    begin
        Apply();
    end else
    begin
        Restore();
        Apply();
    end;
end;

end.
