unit Info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TInfoForm = class(TForm)
    AppIcon: TImage;
    Panel1: TPanel;
    Panel3: TPanel;
    lblMail: TLabel;
    lblURL: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    lblExeName: TLabel;
    lblComment: TLabel;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  InfoForm: TInfoForm;

implementation

uses
    ShellApi;

{$R *.dfm}

function    AppExeName(): string;
begin
    Result := ChangeFileExt(ExtractFileName(Application.ExeName), '');
end;

procedure TInfoForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title;

    lblExeName.Caption := AppExeName(); 
    AppIcon.Picture.Icon := Application.Icon;
end;

procedure   ExecuteFile(const FileName: string);
begin
    try
        ShellExecute(Application.MainForm.Handle, nil, PChar(FileName), nil, nil, SW_SHOW);
    except
        ShowMessage('ɂ');
    end;
end;

procedure TInfoForm.lblURLClick(Sender: TObject);
begin
    ExecuteFile(lblURL.Caption);
end;

procedure TInfoForm.lblMailClick(Sender: TObject);
begin
    ExecuteFile(Format('MailTo:%s?subject=from [%s] user', [lblMail.Caption, AppExeName()]));
end;

procedure TInfoForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_ESCAPE then Self.Close;
end;

end.
